diff --git a/src/backend/utils/adt/enum.c b/src/backend/utils/adt/enum.c
index 0cc7a6d8ad..bb24bd13fa 100644
--- a/src/backend/utils/adt/enum.c
+++ b/src/backend/utils/adt/enum.c
@@ -63,7 +63,7 @@ static void
 check_safe_enum_use(HeapTuple enumval_tup)
 {
 	TransactionId xmin;
-	Form_pg_enum en = (Form_pg_enum) GETSTRUCT(enumval_tup);
+	Form_pg_enum en = GETSTRUCT(pg_enum, enumval_tup);
 
 	/*
 	 * If the row is hinted as committed, it's surely safe.  This provides a
@@ -138,7 +138,7 @@ enum_in(PG_FUNCTION_ARGS)
 	 * This comes from pg_enum.oid and stores system oids in user tables. This
 	 * oid must be preserved by binary upgrades.
 	 */
-	enumoid = ((Form_pg_enum) GETSTRUCT(tup))->oid;
+	enumoid = (GETSTRUCT(pg_enum, tup))->oid;
 
 	ReleaseSysCache(tup);
 
@@ -159,7 +159,7 @@ enum_out(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 				 errmsg("invalid internal value for enum: %u",
 						enumval)));
-	en = (Form_pg_enum) GETSTRUCT(tup);
+	en = GETSTRUCT(pg_enum, tup);
 
 	result = pstrdup(NameStr(en->enumlabel));
 
@@ -202,7 +202,7 @@ enum_recv(PG_FUNCTION_ARGS)
 	/* check it's safe to use in SQL */
 	check_safe_enum_use(tup);
 
-	enumoid = ((Form_pg_enum) GETSTRUCT(tup))->oid;
+	enumoid = (GETSTRUCT(pg_enum, tup))->oid;
 
 	ReleaseSysCache(tup);
 
@@ -225,7 +225,7 @@ enum_send(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 				 errmsg("invalid internal value for enum: %u",
 						enumval)));
-	en = (Form_pg_enum) GETSTRUCT(tup);
+	en = GETSTRUCT(pg_enum, tup);
 
 	pq_begintypsend(&buf);
 	pq_sendtext(&buf, NameStr(en->enumlabel), strlen(NameStr(en->enumlabel)));
@@ -284,7 +284,7 @@ enum_cmp_internal(Oid arg1, Oid arg2, FunctionCallInfo fcinfo)
 					(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 					 errmsg("invalid internal value for enum: %u",
 							arg1)));
-		en = (Form_pg_enum) GETSTRUCT(enum_tup);
+		en = GETSTRUCT(pg_enum, enum_tup);
 		typeoid = en->enumtypid;
 		ReleaseSysCache(enum_tup);
 		/* Now locate and remember the typcache entry */
@@ -412,7 +412,7 @@ enum_endpoint(Oid enumtypoid, ScanDirection direction)
 	{
 		/* check it's safe to use in SQL */
 		check_safe_enum_use(enum_tuple);
-		minmax = ((Form_pg_enum) GETSTRUCT(enum_tuple))->oid;
+		minmax = (GETSTRUCT(pg_enum, enum_tuple))->oid;
 	}
 	else
 	{
@@ -572,7 +572,7 @@ enum_range_internal(Oid enumtypoid, Oid lower, Oid upper)
 
 	while (HeapTupleIsValid(enum_tuple = systable_getnext_ordered(enum_scan, ForwardScanDirection)))
 	{
-		Oid			enum_oid = ((Form_pg_enum) GETSTRUCT(enum_tuple))->oid;
+		Oid			enum_oid = (GETSTRUCT(pg_enum, enum_tuple))->oid;
 
 		if (!left_found && lower == enum_oid)
 			left_found = true;
diff --git a/src/backend/utils/adt/format_type.c b/src/backend/utils/adt/format_type.c
index 060fd7e183..e2e127ac2c 100644
--- a/src/backend/utils/adt/format_type.c
+++ b/src/backend/utils/adt/format_type.c
@@ -136,7 +136,7 @@ format_type_extended(Oid type_oid, int32 typemod, bits16 flags)
 		else
 			elog(ERROR, "cache lookup failed for type %u", type_oid);
 	}
-	typeform = (Form_pg_type) GETSTRUCT(tuple);
+	typeform = GETSTRUCT(pg_type, tuple);
 
 	/*
 	 * Check if it's a "true" array type.  Pseudo-array types such as "name"
@@ -161,7 +161,7 @@ format_type_extended(Oid type_oid, int32 typemod, bits16 flags)
 			else
 				elog(ERROR, "cache lookup failed for type %u", type_oid);
 		}
-		typeform = (Form_pg_type) GETSTRUCT(tuple);
+		typeform = GETSTRUCT(pg_type, tuple);
 		type_oid = array_base_type;
 		is_array = true;
 	}
diff --git a/src/backend/utils/adt/jsonfuncs.c b/src/backend/utils/adt/jsonfuncs.c
index 9819e1a45c..8e70d97c9b 100644
--- a/src/backend/utils/adt/jsonfuncs.c
+++ b/src/backend/utils/adt/jsonfuncs.c
@@ -2997,7 +2997,7 @@ prepare_column_cache(ColumnIOData *column,
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", typid);
 
-	type = (Form_pg_type) GETSTRUCT(tup);
+	type = GETSTRUCT(pg_type, tup);
 
 	if (type->typtype == TYPTYPE_DOMAIN)
 	{
diff --git a/src/backend/utils/adt/like_support.c b/src/backend/utils/adt/like_support.c
index 65a57fc3c4..3884c19aef 100644
--- a/src/backend/utils/adt/like_support.c
+++ b/src/backend/utils/adt/like_support.c
@@ -608,7 +608,7 @@ patternsel_common(PlannerInfo *root,
 	{
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 		nullfrac = stats->stanullfrac;
 	}
 
diff --git a/src/backend/utils/adt/multirangetypes_selfuncs.c b/src/backend/utils/adt/multirangetypes_selfuncs.c
index 919c8889d4..8d2a0977e5 100644
--- a/src/backend/utils/adt/multirangetypes_selfuncs.c
+++ b/src/backend/utils/adt/multirangetypes_selfuncs.c
@@ -306,7 +306,7 @@ calc_multirangesel(TypeCacheEntry *typcache, VariableStatData *vardata,
 		Form_pg_statistic stats;
 		AttStatsSlot sslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 		null_frac = stats->stanullfrac;
 
 		/* Try to get fraction of empty multiranges */
diff --git a/src/backend/utils/adt/network_selfuncs.c b/src/backend/utils/adt/network_selfuncs.c
index 49196376a8..33b45e4d99 100644
--- a/src/backend/utils/adt/network_selfuncs.c
+++ b/src/backend/utils/adt/network_selfuncs.c
@@ -127,7 +127,7 @@ networksel(PG_FUNCTION_ARGS)
 		PG_RETURN_FLOAT8(DEFAULT_SEL(operator));
 	}
 
-	stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+	stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 	nullfrac = stats->stanullfrac;
 
 	/*
@@ -283,7 +283,7 @@ networkjoinsel_inner(Oid operator,
 
 	if (HeapTupleIsValid(vardata1->statsTuple))
 	{
-		stats = (Form_pg_statistic) GETSTRUCT(vardata1->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata1->statsTuple);
 		nullfrac1 = stats->stanullfrac;
 
 		mcv1_exists = get_attstatsslot(&mcv1_slot, vardata1->statsTuple,
@@ -305,7 +305,7 @@ networkjoinsel_inner(Oid operator,
 
 	if (HeapTupleIsValid(vardata2->statsTuple))
 	{
-		stats = (Form_pg_statistic) GETSTRUCT(vardata2->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata2->statsTuple);
 		nullfrac2 = stats->stanullfrac;
 
 		mcv2_exists = get_attstatsslot(&mcv2_slot, vardata2->statsTuple,
@@ -413,7 +413,7 @@ networkjoinsel_semi(Oid operator,
 
 	if (HeapTupleIsValid(vardata1->statsTuple))
 	{
-		stats = (Form_pg_statistic) GETSTRUCT(vardata1->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata1->statsTuple);
 		nullfrac1 = stats->stanullfrac;
 
 		mcv1_exists = get_attstatsslot(&mcv1_slot, vardata1->statsTuple,
@@ -435,7 +435,7 @@ networkjoinsel_semi(Oid operator,
 
 	if (HeapTupleIsValid(vardata2->statsTuple))
 	{
-		stats = (Form_pg_statistic) GETSTRUCT(vardata2->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata2->statsTuple);
 		nullfrac2 = stats->stanullfrac;
 
 		mcv2_exists = get_attstatsslot(&mcv2_slot, vardata2->statsTuple,
diff --git a/src/backend/utils/adt/pg_locale.c b/src/backend/utils/adt/pg_locale.c
index 5cf5dd5f87..42f52fd85f 100644
--- a/src/backend/utils/adt/pg_locale.c
+++ b/src/backend/utils/adt/pg_locale.c
@@ -1283,7 +1283,7 @@ lookup_collation_cache(Oid collation, bool set_flags)
 		tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(collation));
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for collation %u", collation);
-		collform = (Form_pg_collation) GETSTRUCT(tp);
+		collform = GETSTRUCT(pg_collation, tp);
 
 		if (collform->collprovider == COLLPROVIDER_LIBC)
 		{
@@ -1535,7 +1535,7 @@ pg_newlocale_from_collation(Oid collid)
 		tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(collid));
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for collation %u", collid);
-		collform = (Form_pg_collation) GETSTRUCT(tp);
+		collform = GETSTRUCT(pg_collation, tp);
 
 		/* We'll fill in the result struct locally before allocating memory */
 		memset(&result, 0, sizeof(result));
diff --git a/src/backend/utils/adt/rangetypes_selfuncs.c b/src/backend/utils/adt/rangetypes_selfuncs.c
index c2795f4593..70bdbbdf6c 100644
--- a/src/backend/utils/adt/rangetypes_selfuncs.c
+++ b/src/backend/utils/adt/rangetypes_selfuncs.c
@@ -244,7 +244,7 @@ calc_rangesel(TypeCacheEntry *typcache, VariableStatData *vardata,
 		Form_pg_statistic stats;
 		AttStatsSlot sslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 		null_frac = stats->stanullfrac;
 
 		/* Try to get fraction of empty ranges */
diff --git a/src/backend/utils/adt/regproc.c b/src/backend/utils/adt/regproc.c
index 6d4c1c27a5..052374dd23 100644
--- a/src/backend/utils/adt/regproc.c
+++ b/src/backend/utils/adt/regproc.c
@@ -155,7 +155,7 @@ regprocout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(proctup))
 	{
-		Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(proctup);
+		Form_pg_proc procform = GETSTRUCT(pg_proc, proctup);
 		char	   *proname = NameStr(procform->proname);
 
 		/*
@@ -356,7 +356,7 @@ format_procedure_extended(Oid procedure_oid, bits16 flags)
 
 	if (HeapTupleIsValid(proctup))
 	{
-		Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(proctup);
+		Form_pg_proc procform = GETSTRUCT(pg_proc, proctup);
 		char	   *proname = NameStr(procform->proname);
 		int			nargs = procform->pronargs;
 		int			i;
@@ -436,7 +436,7 @@ format_procedure_parts(Oid procedure_oid, List **objnames, List **objargs,
 		return;
 	}
 
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 	nargs = procform->pronargs;
 
 	*objnames = list_make2(get_namespace_name_or_temp(procform->pronamespace),
@@ -593,7 +593,7 @@ regoperout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(opertup))
 	{
-		Form_pg_operator operform = (Form_pg_operator) GETSTRUCT(opertup);
+		Form_pg_operator operform = GETSTRUCT(pg_operator, opertup);
 		char	   *oprname = NameStr(operform->oprname);
 
 		/*
@@ -787,7 +787,7 @@ format_operator_extended(Oid operator_oid, bits16 flags)
 
 	if (HeapTupleIsValid(opertup))
 	{
-		Form_pg_operator operform = (Form_pg_operator) GETSTRUCT(opertup);
+		Form_pg_operator operform = GETSTRUCT(pg_operator, opertup);
 		char	   *oprname = NameStr(operform->oprname);
 		char	   *nspname;
 		StringInfoData buf;
@@ -877,7 +877,7 @@ format_operator_parts(Oid operator_oid, List **objnames, List **objargs,
 		return;
 	}
 
-	oprForm = (Form_pg_operator) GETSTRUCT(opertup);
+	oprForm = GETSTRUCT(pg_operator, opertup);
 	*objnames = list_make2(get_namespace_name_or_temp(oprForm->oprnamespace),
 						   pstrdup(NameStr(oprForm->oprname)));
 	*objargs = NIL;
@@ -1023,7 +1023,7 @@ regclassout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(classtup))
 	{
-		Form_pg_class classform = (Form_pg_class) GETSTRUCT(classtup);
+		Form_pg_class classform = GETSTRUCT(pg_class, classtup);
 		char	   *classname = NameStr(classform->relname);
 
 		/*
@@ -1174,7 +1174,7 @@ regcollationout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(collationtup))
 	{
-		Form_pg_collation collationform = (Form_pg_collation) GETSTRUCT(collationtup);
+		Form_pg_collation collationform = GETSTRUCT(pg_collation, collationtup);
 		char	   *collationname = NameStr(collationform->collname);
 
 		/*
@@ -1326,7 +1326,7 @@ regtypeout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(typetup))
 	{
-		Form_pg_type typeform = (Form_pg_type) GETSTRUCT(typetup);
+		Form_pg_type typeform = GETSTRUCT(pg_type, typetup);
 
 		/*
 		 * In bootstrap mode, skip the fancy namespace stuff and just return
@@ -1439,7 +1439,7 @@ regconfigout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(cfgtup))
 	{
-		Form_pg_ts_config cfgform = (Form_pg_ts_config) GETSTRUCT(cfgtup);
+		Form_pg_ts_config cfgform = GETSTRUCT(pg_ts_config, cfgtup);
 		char	   *cfgname = NameStr(cfgform->cfgname);
 		char	   *nspname;
 
@@ -1550,7 +1550,7 @@ regdictionaryout(PG_FUNCTION_ARGS)
 
 	if (HeapTupleIsValid(dicttup))
 	{
-		Form_pg_ts_dict dictform = (Form_pg_ts_dict) GETSTRUCT(dicttup);
+		Form_pg_ts_dict dictform = GETSTRUCT(pg_ts_dict, dicttup);
 		char	   *dictname = NameStr(dictform->dictname);
 		char	   *nspname;
 
diff --git a/src/backend/utils/adt/ri_triggers.c b/src/backend/utils/adt/ri_triggers.c
index 51b3fdc9a0..33e9cfa567 100644
--- a/src/backend/utils/adt/ri_triggers.c
+++ b/src/backend/utils/adt/ri_triggers.c
@@ -1945,7 +1945,7 @@ ri_GenerateQualCollation(StringInfo buf, Oid collation)
 	tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(collation));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for collation %u", collation);
-	colltup = (Form_pg_collation) GETSTRUCT(tp);
+	colltup = GETSTRUCT(pg_collation, tp);
 	collname = NameStr(colltup->collname);
 
 	/*
@@ -2134,7 +2134,7 @@ ri_LoadConstraintInfo(Oid constraintOid)
 	tup = SearchSysCache1(CONSTROID, ObjectIdGetDatum(constraintOid));
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for constraint %u", constraintOid);
-	conForm = (Form_pg_constraint) GETSTRUCT(tup);
+	conForm = GETSTRUCT(pg_constraint, tup);
 
 	if (conForm->contype != CONSTRAINT_FOREIGN) /* should not happen */
 		elog(ERROR, "constraint %u is not a foreign key constraint",
@@ -2197,7 +2197,7 @@ get_ri_constraint_root(Oid constrOid)
 		tuple = SearchSysCache1(CONSTROID, ObjectIdGetDatum(constrOid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for constraint %u", constrOid);
-		constrParentOid = ((Form_pg_constraint) GETSTRUCT(tuple))->conparentid;
+		constrParentOid = (GETSTRUCT(pg_constraint, tuple))->conparentid;
 		ReleaseSysCache(tuple);
 		if (!OidIsValid(constrParentOid))
 			break;				/* we reached the root constraint */
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 26cf4fa9a0..f1b31fc4e7 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -898,7 +898,7 @@ pg_get_triggerdef_worker(Oid trigid, bool pretty)
 		return NULL;
 	}
 
-	trigrec = (Form_pg_trigger) GETSTRUCT(ht_trig);
+	trigrec = GETSTRUCT(pg_trigger, ht_trig);
 
 	/*
 	 * Start the trigger definition. Note that the trigger's name should never
@@ -1253,7 +1253,7 @@ pg_get_indexdef_worker(Oid indexrelid, int colno,
 			return NULL;
 		elog(ERROR, "cache lookup failed for index %u", indexrelid);
 	}
-	idxrec = (Form_pg_index) GETSTRUCT(ht_idx);
+	idxrec = GETSTRUCT(pg_index, ht_idx);
 
 	indrelid = idxrec->indrelid;
 	Assert(indexrelid == idxrec->indexrelid);
@@ -1280,7 +1280,7 @@ pg_get_indexdef_worker(Oid indexrelid, int colno,
 	ht_idxrel = SearchSysCache1(RELOID, ObjectIdGetDatum(indexrelid));
 	if (!HeapTupleIsValid(ht_idxrel))
 		elog(ERROR, "cache lookup failed for relation %u", indexrelid);
-	idxrelrec = (Form_pg_class) GETSTRUCT(ht_idxrel);
+	idxrelrec = GETSTRUCT(pg_class, ht_idxrel);
 
 	/*
 	 * Fetch the pg_am tuple of the index' access method
@@ -1289,7 +1289,7 @@ pg_get_indexdef_worker(Oid indexrelid, int colno,
 	if (!HeapTupleIsValid(ht_am))
 		elog(ERROR, "cache lookup failed for access method %u",
 			 idxrelrec->relam);
-	amrec = (Form_pg_am) GETSTRUCT(ht_am);
+	amrec = GETSTRUCT(pg_am, ht_am);
 
 	/* Fetch the index AM's API struct */
 	amroutine = GetIndexAmRoutine(amrec->amhandler);
@@ -1637,7 +1637,7 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	/* has the statistics expressions? */
 	has_exprs = !heap_attisnull(statexttup, Anum_pg_statistic_ext_stxexprs, NULL);
 
-	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
+	statextrec = GETSTRUCT(pg_statistic_ext, statexttup);
 
 	/*
 	 * Get the statistics expressions, if any.  (NOTE: we do not use the
@@ -1821,7 +1821,7 @@ pg_get_statisticsobjdef_expressions(PG_FUNCTION_ARGS)
 		PG_RETURN_NULL();
 	}
 
-	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
+	statextrec = GETSTRUCT(pg_statistic_ext, statexttup);
 
 	/*
 	 * Get the statistics expressions, and deparse them into text values.
@@ -1919,7 +1919,7 @@ pg_get_partkeydef_worker(Oid relid, int prettyFlags,
 		elog(ERROR, "cache lookup failed for partition key of %u", relid);
 	}
 
-	form = (Form_pg_partitioned_table) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_partitioned_table, tuple);
 
 	Assert(form->partrelid == relid);
 
@@ -2197,7 +2197,7 @@ pg_get_constraintdef_worker(Oid constraintId, bool fullCommand,
 		elog(ERROR, "could not find tuple for constraint %u", constraintId);
 	}
 
-	conForm = (Form_pg_constraint) GETSTRUCT(tup);
+	conForm = GETSTRUCT(pg_constraint, tup);
 
 	initStringInfo(&buf);
 
@@ -2371,7 +2371,7 @@ pg_get_constraintdef_worker(Oid constraintId, bool fullCommand,
 				if (!HeapTupleIsValid(indtup))
 					elog(ERROR, "cache lookup failed for index %u", indexId);
 				if (conForm->contype == CONSTRAINT_UNIQUE &&
-					((Form_pg_index) GETSTRUCT(indtup))->indnullsnotdistinct)
+					(GETSTRUCT(pg_index, indtup))->indnullsnotdistinct)
 					appendStringInfoString(&buf, "NULLS NOT DISTINCT ");
 
 				appendStringInfoString(&buf, "(");
@@ -2769,7 +2769,7 @@ pg_get_userbyid(PG_FUNCTION_ARGS)
 	roletup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(roletup))
 	{
-		role_rec = (Form_pg_authid) GETSTRUCT(roletup);
+		role_rec = GETSTRUCT(pg_authid, roletup);
 		*result = role_rec->rolname;
 		ReleaseSysCache(roletup);
 	}
@@ -2837,7 +2837,7 @@ pg_get_serial_sequence(PG_FUNCTION_ARGS)
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend deprec = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend deprec = GETSTRUCT(pg_depend, tup);
 
 		/*
 		 * Look for an auto dependency (serial column) or internal dependency
@@ -2905,7 +2905,7 @@ pg_get_functiondef(PG_FUNCTION_ARGS)
 	if (!HeapTupleIsValid(proctup))
 		PG_RETURN_NULL();
 
-	proc = (Form_pg_proc) GETSTRUCT(proctup);
+	proc = GETSTRUCT(pg_proc, proctup);
 	name = NameStr(proc->proname);
 
 	if (proc->prokind == PROKIND_AGGREGATE)
@@ -3197,7 +3197,7 @@ pg_get_function_result(PG_FUNCTION_ARGS)
 	if (!HeapTupleIsValid(proctup))
 		PG_RETURN_NULL();
 
-	if (((Form_pg_proc) GETSTRUCT(proctup))->prokind == PROKIND_PROCEDURE)
+	if ((GETSTRUCT(pg_proc, proctup))->prokind == PROKIND_PROCEDURE)
 	{
 		ReleaseSysCache(proctup);
 		PG_RETURN_NULL();
@@ -3219,7 +3219,7 @@ pg_get_function_result(PG_FUNCTION_ARGS)
 static void
 print_function_rettype(StringInfo buf, HeapTuple proctup)
 {
-	Form_pg_proc proc = (Form_pg_proc) GETSTRUCT(proctup);
+	Form_pg_proc proc = GETSTRUCT(pg_proc, proctup);
 	int			ntabargs = 0;
 	StringInfoData rbuf;
 
@@ -3258,7 +3258,7 @@ static int
 print_function_arguments(StringInfo buf, HeapTuple proctup,
 						 bool print_table_args, bool print_defaults)
 {
-	Form_pg_proc proc = (Form_pg_proc) GETSTRUCT(proctup);
+	Form_pg_proc proc = GETSTRUCT(pg_proc, proctup);
 	int			numargs;
 	Oid		   *argtypes;
 	char	  **argnames;
@@ -3306,7 +3306,7 @@ print_function_arguments(StringInfo buf, HeapTuple proctup,
 		if (!HeapTupleIsValid(aggtup))
 			elog(ERROR, "cache lookup failed for aggregate %u",
 				 proc->oid);
-		agg = (Form_pg_aggregate) GETSTRUCT(aggtup);
+		agg = GETSTRUCT(pg_aggregate, aggtup);
 		if (AGGKIND_IS_ORDERED_SET(agg->aggkind))
 			insertorderbyat = agg->aggnumdirectargs;
 		ReleaseSysCache(aggtup);
@@ -3491,7 +3491,7 @@ pg_get_function_arg_default(PG_FUNCTION_ARGS)
 	argdefaults = castNode(List, stringToNode(str));
 	pfree(str);
 
-	proc = (Form_pg_proc) GETSTRUCT(proctup);
+	proc = GETSTRUCT(pg_proc, proctup);
 
 	/*
 	 * Calculate index into proargdefaults: proargdefaults corresponds to the
@@ -3524,7 +3524,7 @@ print_function_sqlbody(StringInfo buf, HeapTuple proctup)
 	bool		isnull;
 	Node	   *n;
 
-	dpns.funcname = pstrdup(NameStr(((Form_pg_proc) GETSTRUCT(proctup))->proname));
+	dpns.funcname = pstrdup(NameStr((GETSTRUCT(pg_proc, proctup))->proname));
 	numargs = get_func_arg_info(proctup,
 								&argtypes, &argnames, &argmodes);
 	dpns.numargs = numargs;
@@ -12029,7 +12029,7 @@ get_opclass_name(Oid opclass, Oid actual_datatype,
 	ht_opc = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclass));
 	if (!HeapTupleIsValid(ht_opc))
 		elog(ERROR, "cache lookup failed for opclass %u", opclass);
-	opcrec = (Form_pg_opclass) GETSTRUCT(ht_opc);
+	opcrec = GETSTRUCT(pg_opclass, ht_opc);
 
 	if (!OidIsValid(actual_datatype) ||
 		GetDefaultOpClass(actual_datatype, opcrec->opcmethod) != opclass)
@@ -12323,7 +12323,7 @@ generate_relation_name(Oid relid, List *namespaces)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	reltup = (Form_pg_class) GETSTRUCT(tp);
+	reltup = GETSTRUCT(pg_class, tp);
 	relname = NameStr(reltup->relname);
 
 	/* Check for conflicting CTE name */
@@ -12381,7 +12381,7 @@ generate_qualified_relation_name(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	reltup = (Form_pg_class) GETSTRUCT(tp);
+	reltup = GETSTRUCT(pg_class, tp);
 	relname = NameStr(reltup->relname);
 
 	nspname = get_namespace_name_or_temp(reltup->relnamespace);
@@ -12434,7 +12434,7 @@ generate_function_name(Oid funcid, int nargs, List *argnames, Oid *argtypes,
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 	proname = NameStr(procform->proname);
 
 	/*
@@ -12531,7 +12531,7 @@ generate_operator_name(Oid operid, Oid arg1, Oid arg2)
 	opertup = SearchSysCache1(OPEROID, ObjectIdGetDatum(operid));
 	if (!HeapTupleIsValid(opertup))
 		elog(ERROR, "cache lookup failed for operator %u", operid);
-	operform = (Form_pg_operator) GETSTRUCT(opertup);
+	operform = GETSTRUCT(pg_operator, opertup);
 	oprname = NameStr(operform->oprname);
 
 	/*
@@ -12607,7 +12607,7 @@ generate_operator_clause(StringInfo buf,
 	opertup = SearchSysCache1(OPEROID, ObjectIdGetDatum(opoid));
 	if (!HeapTupleIsValid(opertup))
 		elog(ERROR, "cache lookup failed for operator %u", opoid);
-	operform = (Form_pg_operator) GETSTRUCT(opertup);
+	operform = GETSTRUCT(pg_operator, opertup);
 	Assert(operform->oprkind == 'b');
 	oprname = NameStr(operform->oprname);
 
@@ -12644,7 +12644,7 @@ add_cast_to(StringInfo buf, Oid typid)
 	typetup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(typetup))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typform = (Form_pg_type) GETSTRUCT(typetup);
+	typform = GETSTRUCT(pg_type, typetup);
 
 	typname = NameStr(typform->typname);
 	nspname = get_namespace_name_or_temp(typform->typnamespace);
@@ -12676,7 +12676,7 @@ generate_qualified_type_name(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typtup = (Form_pg_type) GETSTRUCT(tp);
+	typtup = GETSTRUCT(pg_type, tp);
 	typname = NameStr(typtup->typname);
 
 	nspname = get_namespace_name_or_temp(typtup->typnamespace);
@@ -12709,7 +12709,7 @@ generate_collation_name(Oid collid)
 	tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(collid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for collation %u", collid);
-	colltup = (Form_pg_collation) GETSTRUCT(tp);
+	colltup = GETSTRUCT(pg_collation, tp);
 	collname = NameStr(colltup->collname);
 
 	if (!CollationIsVisible(collid))
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index fa1f589fad..81eb913317 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -313,7 +313,7 @@ var_eq_const(VariableStatData *vardata, Oid operator, Oid collation,
 	{
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 		nullfrac = stats->stanullfrac;
 	}
 
@@ -475,7 +475,7 @@ var_eq_non_const(VariableStatData *vardata, Oid operator, Oid collation,
 	{
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 		nullfrac = stats->stanullfrac;
 	}
 
@@ -665,7 +665,7 @@ scalarineqsel(PlannerInfo *root, Oid operator, bool isgt, bool iseq,
 		/* no stats available, so default result */
 		return DEFAULT_INEQ_SEL;
 	}
-	stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+	stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 
 	fmgr_info(get_opcode(operator), &opproc);
 
@@ -990,7 +990,7 @@ generic_restriction_selectivity(PlannerInfo *root, Oid oproid, Oid collation,
 
 		/* Don't forget to account for nulls. */
 		if (HeapTupleIsValid(vardata.statsTuple))
-			nullfrac = ((Form_pg_statistic) GETSTRUCT(vardata.statsTuple))->stanullfrac;
+			nullfrac = (GETSTRUCT(pg_statistic, vardata.statsTuple))->stanullfrac;
 		else
 			nullfrac = 0.0;
 
@@ -1548,7 +1548,7 @@ booltestsel(PlannerInfo *root, BoolTestType booltesttype, Node *arg,
 		double		freq_null;
 		AttStatsSlot sslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 		freq_null = stats->stanullfrac;
 
 		if (get_attstatsslot(&sslot, vardata.statsTuple,
@@ -1705,7 +1705,7 @@ nulltestsel(PlannerInfo *root, NullTestType nulltesttype, Node *arg,
 		Form_pg_statistic stats;
 		double		freq_null;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 		freq_null = stats->stanullfrac;
 
 		switch (nulltesttype)
@@ -2277,7 +2277,7 @@ eqjoinsel(PG_FUNCTION_ARGS)
 	if (HeapTupleIsValid(vardata1.statsTuple))
 	{
 		/* note we allow use of nullfrac regardless of security check */
-		stats1 = (Form_pg_statistic) GETSTRUCT(vardata1.statsTuple);
+		stats1 = GETSTRUCT(pg_statistic, vardata1.statsTuple);
 		if (statistic_proc_security_check(&vardata1, opfuncoid))
 			have_mcvs1 = get_attstatsslot(&sslot1, vardata1.statsTuple,
 										  STATISTIC_KIND_MCV, InvalidOid,
@@ -2287,7 +2287,7 @@ eqjoinsel(PG_FUNCTION_ARGS)
 	if (HeapTupleIsValid(vardata2.statsTuple))
 	{
 		/* note we allow use of nullfrac regardless of security check */
-		stats2 = (Form_pg_statistic) GETSTRUCT(vardata2.statsTuple);
+		stats2 = GETSTRUCT(pg_statistic, vardata2.statsTuple);
 		if (statistic_proc_security_check(&vardata2, opfuncoid))
 			have_mcvs2 = get_attstatsslot(&sslot2, vardata2.statsTuple,
 										  STATISTIC_KIND_MCV, InvalidOid,
@@ -2804,7 +2804,7 @@ neqjoinsel(PG_FUNCTION_ARGS)
 		get_join_variables(root, args, sjinfo, &leftvar, &rightvar, &reversed);
 		statsTuple = reversed ? rightvar.statsTuple : leftvar.statsTuple;
 		if (HeapTupleIsValid(statsTuple))
-			nullfrac = ((Form_pg_statistic) GETSTRUCT(statsTuple))->stanullfrac;
+			nullfrac = (GETSTRUCT(pg_statistic, statsTuple))->stanullfrac;
 		else
 			nullfrac = 0.0;
 		ReleaseVariableStats(leftvar);
@@ -3162,7 +3162,7 @@ mergejoinscansel(PlannerInfo *root, Node *clause,
 
 		if (HeapTupleIsValid(leftvar.statsTuple))
 		{
-			stats = (Form_pg_statistic) GETSTRUCT(leftvar.statsTuple);
+			stats = GETSTRUCT(pg_statistic, leftvar.statsTuple);
 			*leftstart += stats->stanullfrac;
 			CLAMP_PROBABILITY(*leftstart);
 			*leftend += stats->stanullfrac;
@@ -3170,7 +3170,7 @@ mergejoinscansel(PlannerInfo *root, Node *clause,
 		}
 		if (HeapTupleIsValid(rightvar.statsTuple))
 		{
-			stats = (Form_pg_statistic) GETSTRUCT(rightvar.statsTuple);
+			stats = GETSTRUCT(pg_statistic, rightvar.statsTuple);
 			*rightstart += stats->stanullfrac;
 			CLAMP_PROBABILITY(*rightstart);
 			*rightend += stats->stanullfrac;
@@ -3830,7 +3830,7 @@ estimate_hash_bucket_stats(PlannerInfo *root, Node *hashkey, double nbuckets,
 	{
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 		stanullfrac = stats->stanullfrac;
 	}
 	else
@@ -5672,7 +5672,7 @@ get_variable_numdistinct(VariableStatData *vardata, bool *isdefault)
 		/* Use the pg_statistic entry */
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 		stadistinct = stats->stadistinct;
 		stanullfrac = stats->stanullfrac;
 	}
@@ -5889,7 +5889,7 @@ get_variable_range(PlannerInfo *root, VariableStatData *vardata,
 
 			for (i = 0; i < sslot.nnumbers; i++)
 				sumcommon += sslot.numbers[i];
-			nullfrac = ((Form_pg_statistic) GETSTRUCT(vardata->statsTuple))->stanullfrac;
+			nullfrac = (GETSTRUCT(pg_statistic, vardata->statsTuple))->stanullfrac;
 			if (sumcommon + nullfrac > 0.99999)
 				use_mcvs = true;
 		}
diff --git a/src/backend/utils/adt/xml.c b/src/backend/utils/adt/xml.c
index 60a85c4697..0ce9012784 100644
--- a/src/backend/utils/adt/xml.c
+++ b/src/backend/utils/adt/xml.c
@@ -3183,7 +3183,7 @@ map_sql_table_to_xmlschema(TupleDesc tupdesc, Oid relid, bool nulls,
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for relation %u", relid);
-		reltuple = (Form_pg_class) GETSTRUCT(tuple);
+		reltuple = GETSTRUCT(pg_class, tuple);
 
 		xmltn = map_sql_identifier_to_xml_name(NameStr(reltuple->relname),
 											   true, false);
@@ -3483,7 +3483,7 @@ map_sql_type_to_xml_name(Oid typeoid, int typmod)
 				tuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typeoid));
 				if (!HeapTupleIsValid(tuple))
 					elog(ERROR, "cache lookup failed for type %u", typeoid);
-				typtuple = (Form_pg_type) GETSTRUCT(tuple);
+				typtuple = GETSTRUCT(pg_type, tuple);
 
 				appendStringInfoString(&result,
 									   map_multipart_sql_identifier_to_xml_name((typtuple->typtype == TYPTYPE_DOMAIN) ? "Domain" : "UDT",
diff --git a/src/backend/utils/cache/evtcache.c b/src/backend/utils/cache/evtcache.c
index f7f7165f7f..a6893f9947 100644
--- a/src/backend/utils/cache/evtcache.c
+++ b/src/backend/utils/cache/evtcache.c
@@ -153,7 +153,7 @@ BuildEventTriggerCache(void)
 			break;
 
 		/* Skip trigger if disabled. */
-		form = (Form_pg_event_trigger) GETSTRUCT(tup);
+		form = GETSTRUCT(pg_event_trigger, tup);
 		if (form->evtenabled == TRIGGER_DISABLED)
 			continue;
 
diff --git a/src/backend/utils/cache/inval.c b/src/backend/utils/cache/inval.c
index eb5782f82a..8e100862bf 100644
--- a/src/backend/utils/cache/inval.c
+++ b/src/backend/utils/cache/inval.c
@@ -1259,7 +1259,7 @@ CacheInvalidateHeapTuple(Relation relation,
 	 */
 	if (tupleRelId == RelationRelationId)
 	{
-		Form_pg_class classtup = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classtup = GETSTRUCT(pg_class, tuple);
 
 		relationId = classtup->oid;
 		if (classtup->relisshared)
@@ -1269,7 +1269,7 @@ CacheInvalidateHeapTuple(Relation relation,
 	}
 	else if (tupleRelId == AttributeRelationId)
 	{
-		Form_pg_attribute atttup = (Form_pg_attribute) GETSTRUCT(tuple);
+		Form_pg_attribute atttup = GETSTRUCT(pg_attribute, tuple);
 
 		relationId = atttup->attrelid;
 
@@ -1287,7 +1287,7 @@ CacheInvalidateHeapTuple(Relation relation,
 	}
 	else if (tupleRelId == IndexRelationId)
 	{
-		Form_pg_index indextup = (Form_pg_index) GETSTRUCT(tuple);
+		Form_pg_index indextup = GETSTRUCT(pg_index, tuple);
 
 		/*
 		 * When a pg_index row is updated, we should send out a relcache inval
@@ -1300,7 +1300,7 @@ CacheInvalidateHeapTuple(Relation relation,
 	}
 	else if (tupleRelId == ConstraintRelationId)
 	{
-		Form_pg_constraint constrtup = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint constrtup = GETSTRUCT(pg_constraint, tuple);
 
 		/*
 		 * Foreign keys are part of relcache entries, too, so send out an
@@ -1398,7 +1398,7 @@ CacheInvalidateRelcacheAll(void)
 void
 CacheInvalidateRelcacheByTuple(HeapTuple classTuple)
 {
-	Form_pg_class classtup = (Form_pg_class) GETSTRUCT(classTuple);
+	Form_pg_class classtup = GETSTRUCT(pg_class, classTuple);
 	Oid			databaseId;
 	Oid			relationId;
 
